story6/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('story6unittesting.urls')),
]

story6unittesting/urls.py
from django.urls import path
from . import views

app_name = 'story6unittesting'

urlpatterns = [
    path('', views.events, name='event'),
    path('add/<str:nama_event>', views.eventsGuestForm, name='eventGuestsAdd'),
    path('deleteEvent/', views.deleteEvent, name='deleteEvent'),
    # dilanjutkan ...
]

story6unittesting/models.py
from django.db import models

# Create your models here.
# test


class Events(models.Model):
    nama_event = models.CharField(max_length=50, unique=True)
    deskripsi = models.TextField(max_length=250)

    def __str__(self):
        return "{}".format(self.nama_event)

    class Meta:
        verbose_name = 'Event'


class EventGuests(models.Model):
    event_host = models.ForeignKey(Events, on_delete=models.CASCADE)
    guest = models.CharField(max_length=50, unique=True)

    def __str__(self):
        return "{}".format(self.guest)

    class Meta:
        verbose_name = 'Event Guest'

story6unittesting/forms.py
from django import forms
from . import models


class EventsForm(forms.ModelForm):
    nama_event = forms.CharField(max_length=50, widget=forms.TextInput(
        attrs={
            'class': 'form-control mx-auto',
            'placeholder': "place your name here...",
            'style': 'width: 50%;'
        },
    ))

    deskripsi = forms.CharField(max_length=250, widget=forms.Textarea(
        attrs={
            'class': 'form-control mx-auto',
            'placeholder': "place your event's name here...",
            'style': 'width: 50%; height: 10vh; overflow: auto;'
        },
    ))

    class Meta:
        model = models.Events
        fields = (
            'nama_event',
            'deskripsi',
        )


class EventGuestsForm(forms.ModelForm):
    guest = forms.CharField(max_length=50, widget=forms.TextInput(
        attrs={
            'class': 'form-control mx-auto',
            'placeholder': "place your name here...",
            'style': 'width: 50%;'
        },
    ))

    class Meta:
        model = models.EventGuests
        fields = (
            'guest',
        )

story6unittesting/views.py
from django.shortcuts import render, redirect, get_object_or_404
from django.urls import reverse
from .models import Events, EventGuests
from .forms import EventsForm, EventGuestsForm

# Create your views here.


def events(request):
    event = Events.objects.all()
    guests = EventGuests.objects.all()

    if request.method == 'POST':
        form = EventsForm(request.POST)
        if form.is_valid():
            form.save()  # versi 1
            # models.EventsForm(**form.cleaned_data).save() # versi 2
            form = EventsForm()

    else:
        form = EventsForm()

    return render(request, 'events.html', {'form': form, 'event': event, 'guests': guests})


def eventsGuestForm(request, nama_event):
    event = get_object_or_404(Events, nama_event=nama_event)

    if request.method == 'POST':
        guestform = EventGuestsForm(request.POST)
        if guestform.is_valid():
            guest = guestform.save(commit=False)
            guest.event_host = event
            guest.save()

            # guestform.event_host = event
            # guestform.save() # versi 1
            # models.EventsForm(**form.cleaned_data).save() # versi 2
            # guestform = EventsGuestForm()
            return redirect('/')

    else:
        guestform = EventGuestsForm()

    return render(request, 'eventGuestForm.html', {'event': event, 'guestform': guestform})


def deleteEvent(request):
    if request.method == 'POST' and 'id' in request.POST:
        Events.objects.get(id=request.POST['id']).delete()
    return redirect(reverse('story6unittesting:events'))

story6unittesting/templates/eventGuestForm.html
<!DOCTYPE html>

{% include "eventbase.html" %}

{% block content %}

<div class="container bodyblock">

    <div class="mb-3 title text-center">
        <h3>Join me at this event!</h3>
        <h1>{{ event.nama_event }}</h1>
    </div>

    <form method="POST">
        {% csrf_token %}
        {{ guestform.as_p }}

        <button type="submit" class="button button-modal mt-3">
            <h6>join now!</h6>
        </button>
    </form>

</div>

{% endblock %}

story6unittesting/templates/eventbase.html
<!DOCTYPE html>

{% load static %}

<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link href="{% static 'style.css' %}" rel="stylesheet" type="text/css">
    <link href="https://fonts.googleapis.com/css2?family=Berkshire+Swash&display=swap" rel="stylesheet">
    <title>erika's events | join me!</title>
</head>

<body>
    {% block content %}
    <!-- Content Goes here -->
    {% endblock content %}

</body>

</html>

story6unittesting/templates/events.html
<!DOCTYPE html>

{% include "eventbase.html" %}

{% block content %}

<div class="container">

    <h3 class="text-center">erika's upcoming events</h3>


    <div id="jadwal">

        <form method="POST">
            <div id="academic-formgroup">
                {% csrf_token %}
                {{ form.as_p }}
            </div>

            <button type="submit" class="button mt-3">Submit</button>
        </form>
    </div>

    <div class="text-center schedule-card">
        <h4 class="mb-5">All the upcoming events:</h4>

        <div class="row">

            {% for i in event %}
            <div class="schedule-card-single text-left col-lg-4 col-md-6 d-flex flex-column">
                <form action="{% url 'story6unittesting:deleteEvent' %}" method="POST" class="text-left">
                    {% csrf_token %}
                    <input type="hidden" value="{{ i.id }}" name="id">


                    <button type="submit" class="delete-button"></button>
                    <h6 class="d-inline">delete</h6>
                    </button>
                </form>
                <h4><span class="academic-schedule-label"></span>{{ i.nama_event }}</h4>
                <p><span class="academic-schedule-label">Description : </span>{{ i.deskripsi }}</p>
                <div class="">
                    <p><span class="academic-schedule-label">People/Guests : </span>
                        {% for guest in guests %}
                        {% if guest.event_host == i %}
                        <span class="list-items d-block ml-5">• {{ guest.guest }}</span>
                        {% endif %}
                        {% endfor %}
                    </p>
                </div>

                <button type="submit" class="button button-modal mt-auto"><a
                        href="{% url 'story6unittesting:eventGuestsAdd' i.nama_event %}">
                        <h6>join?</h6>
                    </a></button>

            </div>
            {% endfor %}
        </div>

    </div>

</div>

{% endblock %}